unit modulis;

interface

type sarasas = ^elem;
     elem = record
                inf:string;
                kitas:sarasas
            end;

     AVLmedis = ^elementas;
     elementas = record
            info:string;
            aukstis:integer;
            k,d:AVLmedis;
            end;

procedure iterpti(var saras:sarasas; elementas:integer; iterpt:string);
function pabaigosSimbolis(c:char):boolean;
function aukstis(m:AVLmedis):integer;
function max(a,b:integer):integer;
procedure isarasa (var saras:sarasas; s:string; pradziaARBApabaiga:integer);
procedure pakeisti (var saras:sarasas; elem:integer; pakeisti:string);
procedure spausdinti (saras:sarasas; isvedimas:integer; var rez:text);
procedure nuskaityti(var saras:sarasas; ivedimas:integer; var duom:text);
procedure ismesti(var sarasa:sarasas;raide:char);
procedure itraukti_i_AVL(var m:AVlmedis;s:string);
procedure kairen (var m : AVLmedis);
procedure desinen (var m : AVLmedis) ;
procedure dvigubasKairen(var m:AVLmedis);
procedure dvigubasDesinen(var m:AVLmedis);
procedure spausdInOrder(var m:AVLmedis;  var rez:text);     {Spausdina AVL medi i faila (a+b) }
procedure spausdInOrder_1(var m:AVLmedis);                  {Spausdina AVL medi ekrane (a+b) }
procedure spausdPreOrder(var m:AVLmedis;var rez:text);      {Spausdina AVL medi i faila (+ab) }
procedure spausdPreOrder_1(var m:AVLmedis);                 {Spausdina AVL medi ekrane (+ab) }
procedure spausdPostOrder(var m:AVLmedis;var rez:text);     {Spausdina AVL medi i faila (ab+) }
procedure spausdPostOrder_1(var m:AVLmedis);                {Spausdina AVL medi ekrane (ab+) }

implementation

procedure iterpti(var saras:sarasas; elementas:integer; iterpt:string);
var saras2,saras3:sarasas;
    i:integer;
begin
     saras2:=saras;
     i:=1;
     while (i < elementas) and (saras2 <> nil) do
     begin
             saras2:=saras2^.kitas;
             i:=i + 1;
     end;
     if i < elementas then writeln('Zodis nerastas.')
     else begin
       new(saras3);
       saras3^.inf:=iterpt;
       saras3^.kitas:=saras2^.kitas;
       saras2^.kitas:=saras3;
       //writeln('Iterpta sekmingai.');
     end;
end;

function pabaigosSimbolis(c:char):boolean;
begin
     if (c = ' ') or (c = '.') or (c = ',')
     then
     pabaigosSimbolis:=true
     else
     pabaigosSimbolis:=false
end;

function aukstis(m:AVLmedis):integer;
begin
    if m=nil then aukstis:=-1
    else aukstis:=m^.aukstis;
end;

function max(a,b:integer):integer;
begin
    if a>b then max:=a
    else max:=b;
end;

procedure isarasa (var saras:sarasas; s:string; pradziaARBApabaiga:integer);
var saras2,saras3:sarasas;
begin
        if pradziaARBApabaiga = 1 then
     if saras = nil then
     begin
       saras^.inf:=s;
       saras^.kitas:=nil;
     end
     else
     begin
       new(saras2);
       saras2^.inf:=s;
       saras2^.kitas:=saras;
       saras:=saras2;
     end
   else
   begin
       new(saras2);
       saras2^.inf:=s;
       saras2^.kitas:=nil;
       if saras = nil then saras:=saras2
       else begin
          new(saras3);
          saras3:=saras;
          while saras3^.kitas <> nil do saras3:=saras3^.kitas;
          saras3^.kitas:=saras2;
       end;
   end;
end;

procedure pakeisti (var saras:sarasas; elem:integer; pakeisti:string);
var saras2:sarasas;
    i:integer;
begin
     if saras = nil then writeln('Sarasas tuscias.')
     else begin
       saras2:=saras;
       for i:=2 to elem do
       begin
          saras2:=saras2^.kitas;
          if saras2^.kitas = nil then break;
       end;
       if (i = elem) or (elem = 1) then
       begin
            saras2^.inf:=pakeisti;
            //writeln('Zodis pakeistas sekmingai.');
       end
       else writeln('Toks zodis nerastas.');
     end;
end;


procedure spausdinti (saras:sarasas; isvedimas:integer; var rez:text);
var saras2:sarasas;
    klavisas:char;
    numeris:integer;
begin
     saras2:=saras;
     numeris:=0;
     while saras2 <> nil do
     begin
          numeris:=numeris+1;
          if isvedimas = 2 then
                                begin
                                        write(numeris,': ');
                                        writeln(saras2^.inf);
                                end
                           else
                                begin
                                        write(rez,numeris,': ');
                                        writeln(rez,saras2^.inf);

                                end;
          saras2:=saras2^.kitas
     end;
     if isvedimas = 2 then
     {$I-}
     writeln(rez,'');
     {$I+}
     if IOResult = 0 then close(rez);
     //klavisas:=readkey;
end;

procedure nuskaityti(var saras:sarasas; ivedimas:integer; var duom:text);
var eilute,zodis:string;
    ilg,i:integer;
    simb:char;
begin
  saras:=nil;
  if ivedimas = 2 then
  begin
     saras:=nil;
     write('Iveskite teksta klaviatura:');
     writeln();
     readln(eilute);
     eilute:=eilute + ' ';
     zodis:='';
     ilg:=length(eilute);
     if ilg > 1 then
     for i:=1 to ilg do
            begin
                  simb:=eilute[i];
                  if pabaigosSimbolis(simb) then
                  begin
                        if length(zodis) <> 0 then
                        begin
                          Isarasa(saras, zodis, 0);
                          zodis:='';
                        end;
                  end
                  else begin
                        if length(zodis) = 0 then zodis:=simb
                        else zodis:=zodis + simb;
                  end;
            end;
  end
  else
  begin
  while not eof(duom) do
  begin
     readln(duom, eilute);
     eilute:=eilute + ' ';
     zodis:='';
     ilg:=length(eilute);
     if ilg > 1 then
     for i:=1 to ilg do
            begin
                  simb:=eilute[i];
                  if pabaigosSimbolis(simb) then
                  begin
                        if length(zodis) <> 0 then
                        begin
                          Isarasa(saras, zodis, 0);
                          zodis:='';
                        end;
                  end
                  else begin
                        if length(zodis) = 0 then zodis:=simb
                        else zodis:=zodis + simb;
                  end;
            end;
  end;
  {$I-}
  readln(duom,eilute);
  {$I+}
  if IOResult = 0 then close(duom);
  end;
end;

procedure ismesti(var sarasa:sarasas;raide:char);
var saras,saras2:sarasas;
    k:integer;
    rasta:boolean;
begin
     saras:=sarasa;
     saras2:=nil;
     while saras <> nil do
     begin
            rasta:=true;
            for k:=1 to length(saras^.inf) do begin
            if saras^.inf[k]=raide then
                   begin
                         rasta:=false;
                         break;
                   end;
            end;
            if rasta then Isarasa(saras2,saras^.inf,0);
            saras:=saras^.kitas
     end;

     sarasa:=saras2;
end;

procedure itraukti_i_AVL(var m:AVlmedis;s:string) ;
begin
    if m=nil then begin
                    new(m);
                    m^.info:=s;
                    m^.aukstis:=0;
                    m^.k:=nil;
                    m^.d:=nil;
                    end
    else if s < m^.info then
                        begin
                            itraukti_i_AVL(m^.k,s);
                            if aukstis(m^.k) - aukstis(m^.d)=2 then
                                if s<m^.k^.info then desinen(m)
                                else dvigubasDesinen(m)
                            else m^.aukstis:= max(aukstis(m^.k),aukstis(m^.d))+1
                        end
        else             begin
                              itraukti_i_AVL(m^.d,s);
                              if aukstis(m^.d) - aukstis(m^.k)=2 then
                                  if s>m^.d^.info then kairen(m)
                                  else dvigubasKairen(m)
                              else m^.aukstis:=max(aukstis(m^.k),aukstis(m^.d))+1
                        end;
end;

procedure kairen (var m : AVLmedis) ;
var r: AVLmedis;
begin
    r:=m;
    m:=m^.d;
    r^.d:=m^.k;
    m^.aukstis := max (aukstis (m^.k), aukstis (m^.d)) + 1;
    r^.aukstis := max (m^.aukstis, aukstis (r^.d)) + 1;
    m^.k:=r;
end;

procedure desinen (var m : AVLmedis) ;
var r: AVLmedis;
begin
    r:=m;
    m:=m^.k;
    r^.k:=m^.d;
    m^.aukstis := max (aukstis (m^.k), aukstis (m^.d)) + 1;
    r^.aukstis := max (m^.aukstis, aukstis (r^.d)) + 1;
    m^.d:=r;
end;

procedure dvigubasKairen(var m:AVLmedis)   ;
begin
    desinen(m^.d);
    kairen(m)
end;

procedure dvigubasDesinen(var m:AVLmedis);
begin
    kairen(m^.k);
    desinen(m);
end;

procedure spausdInOrder(var m:AVLmedis; var rez:text);
begin
  if m <> nil then
  begin
     spausdInOrder(m^.k,rez);
     writeln(rez,m^.info) ;
     spausdInOrder(m^.d,rez);
  end
end;

procedure spausdInOrder_1(var m:AVLmedis);
begin
  if m <> nil then
  begin
     spausdInOrder_1(m^.k);
     writeln(m^.info) ;
     spausdInOrder_1(m^.d);
  end
end;

procedure spausdPreOrder(var m:AVLmedis;var rez:text);
begin
  if m <> nil then
  begin

     spausdPreOrder(m^.k,rez);  writeln(m^.info) ;
     spausdPreOrder(m^.d,rez);
  end
end;

procedure spausdPreOrder_1(var m:AVLmedis);
begin
  if m <> nil then
  begin
     writeln(m^.info) ;
     spausdPreOrder_1(m^.k);
     spausdPreOrder_1(m^.d);
  end
end;

procedure spausdPostOrder(var m:AVLmedis;var rez:text);
begin
  if m <> nil then
  begin
     spausdPostOrder(m^.k,rez);
     spausdPostOrder(m^.d,rez);
     writeln(m^.info) ;
  end
end;

procedure spausdPostOrder_1(var m:AVLmedis);
begin
  if m <> nil then
  begin
     spausdPostOrder_1(m^.k);
     spausdPostOrder_1(m^.d);
     writeln(m^.info) ;
  end
end;

end.

